/* GCC */

#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <deque>

//#define DEBUG //fucked gdb,that doesn't show STL containers

void generatePrefix(const std::vector<std::vector<long long> >& matrix,
                    std::deque<long long>& prefix,int position,long long value)
{
    if(position == matrix.size()/2)
    {
        prefix.push_back(value);
        return;
    }
    for(int i = 0;i < matrix[position].size();i++)
        generatePrefix(matrix,prefix,position+1,value + matrix[position][i]);
}

void generatePostfix(const std::vector<std::vector<long long> >& matrix,
                     std::deque<long long>& postfix,int position,long long value)
{
    if(position == matrix.size())
    {
        postfix.push_back(value);
        return;
    }
    for(int i = 0;i < matrix[position].size();i++)
        generatePostfix(matrix,postfix,position+1,value + matrix[position][i]);
}

int countMoreThan(const std::vector<std::vector<long long> >& matrix,
                  std::deque<long long>& prefix,std::deque<long long>& postfix,long long value)
{
    int answer = 0;
    for(std::deque<long long>::reverse_iterator i = prefix.rbegin();i != prefix.rend();i++)
    {
        std::deque<long long>::iterator j = postfix.begin();
        while((j != postfix.end()) && (*i + *j <= value))
            j++;
        answer += postfix.end() - j;
    }
    return answer;
}

bool findWord(const std::vector<std::vector<long long> >& matrix,
              std::vector<char>& current,int position,long long value)
{
    if(value < 0)
        return false;
    if(position == current.size())
        return value == 0;
    for(int i = 0;i < matrix[position].size();i++)
    {
        current[position] = 'a' + i;
        if(findWord(matrix,current,position + 1,value - matrix[position][i]))
        {
            std::cout << current[position];
            return true;
        }
    }
    return false;
}

#ifdef DEBUG

template <template<class> class C,class T>
void debug(const C<T>& smth)
{
    for(int i = 0;i < smth.size();i++)
        std::cout << smth[i] << ' ';
    std::cout << std::endl;
}

#endif

int main()
{
    std::ifstream in("aliens.in");
    int n,m,k;
    in >> n >> m >> k;
    std::vector<std::vector<long long> > matrix(m,std::vector<long long>(n));
    for(int i = 0;i < matrix.size();i++)
        for(int j = 0;j < matrix[i].size();j++)
            in >> matrix[i][j];
    in.close();
    std::deque<long long> prefix,postfix;
    generatePrefix(matrix,prefix,0,0);
    generatePostfix(matrix,postfix,matrix.size()/2,0);
    std::sort(prefix.begin(),prefix.end());
    std::sort(postfix.begin(),postfix.end());
#ifdef DEBUG
    debug(prefix);
    debug(postfix);
#endif
    long long maxValue = 0;
    long long minValue = 0;
    for(int i = 0;i < matrix.size();i++)
    {
        maxValue += *std::max_element(matrix[i].begin(),matrix[i].end());
        minValue += *std::min_element(matrix[i].begin(),matrix[i].end());
    }
    long long value;
    for(value = (minValue + maxValue)/2;minValue != maxValue;value = (minValue + maxValue)/2)
    {
        int number = countMoreThan(matrix,prefix,postfix,value);
        if(number > k)
            minValue = (minValue + maxValue)/2;
        else if(number < k)
            maxValue = (minValue + maxValue)/2;
        else
            minValue++;
    }
    std::vector<char> answer(matrix.size());
    findWord(matrix,answer,0,value);
    std::ofstream out("aliens.out");
    for(int i = 0;i < answer.size();i++)
        out << answer[i];
    out << std::endl;
    out.close();
}
