/* GCC */

#include <iostream>
#include <fstream>
#include <vector>

//#define DEBUG //fucked gdb,that doesn't show STL containers

const int modulus = 1000*1000*1000 + 7;
const int prime = 113;

bool isPalindrom(const std::vector<long long>& hash,const std::vector<long long>& reverse,
                 const std::vector<long long>& power,int left,int right)
{
    if(right <= left)
        return true;
    return (hash[right] - (left > 0 ? hash[left - 1] : 0) * power[right - left + 1] % modulus + modulus) % modulus ==
           (reverse[left] - (right < reverse.size() - 2 ? reverse[right + 1] : 0) * power[right - left + 1] % modulus + modulus) % modulus;
}

#ifdef DEBUG

template <class T>
void debug(const std::vector<T>& smth)
{
    for(int i = 0;i < smth.size();i++)
        std::cout << smth[i] << ' ';
    std::cout << std::endl;
}

#endif

int main()
{
    std::ifstream in("symmetry.in");
    std::ofstream out("symmetry.out");
    int t;
    in >> t;
    for(int _ = 0;_ < t;_++)
    {
        int n;
        in >> n;
        std::vector<int> point(n);
        for(int i = 0;i < point.size();i++)
            in >> point[i];
        std::vector<int> difference(point.size()-1);
        for(int i = 0;i < difference.size();i++)
        {
            difference[i] = point[i+1] - point[i];
        }
        std::vector<long long> hash(difference.size());
        hash.front() = difference.front();
        for(int i = 1;i < hash.size();i++)
            hash[i] = ((hash[i-1] * prime) % modulus + difference[i]) % modulus;
        std::vector<long long> reverse(difference.size());
        reverse.back() = difference.back();
        for(int i = reverse.size()-2;i >= 0;i--)
            reverse[i] = ((reverse[i+1] * prime) % modulus + difference[i]) % modulus;
        std::vector<long long> power(point.size());
        power.front() = 1;
        for(int i = 1;i < power.size();i++)
            power[i] = (power[i-1] % modulus * prime) % modulus;
#ifdef DEBUG
        debug(difference);
        debug(hash);
        debug(reverse);
        debug(power);
#endif
        bool found = false;
        int border;
        for(border = 0;border < point.size() - 1;border++)
        {
            if(isPalindrom(hash,reverse,power,0,border-1) &&
               isPalindrom(hash,reverse,power,border+1,point.size()-1-1))
            {
                found = true;
                break;
            }
        }
        if(found)
            out << border+1 << std::endl;
        else
            out << 0 << std::endl;
    }
    in.close();
    out.close();
}
