/* GCC */
#include <iostream>
#include <cstdio>
#include <map>
#include <algorithm>

using namespace std;

int N , M , suf_cnt , pref_cnt , L;
long long K , Cost[20][20] , min_cost , max_cost , pref[1048576] , suf[1048576] ;
map <long long , int> S;


void generate_pref(int pos , long long cur_cost){
  if ( pos == L + 1 )
        pref[pref_cnt ++ ] = cur_cost;
  else
  for (int i = 1 ; i <= N ; i ++ )
    generate_pref(pos + 1 , cur_cost + Cost[pos][i]);
};

void generate_suf(int pos , long long cur_cost){
  if ( pos == M + 1 )
        suf[suf_cnt ++ ] = cur_cost , S[cur_cost] ++;
  else
  for (int i = 1 ; i <= N ; i ++ )
    generate_suf(pos + 1 , cur_cost + Cost[pos][i]);
};

long long count_more(long long cost){
  long long answer = 0;
  int it = 0;
  for (int i = pref_cnt - 1 ; i >= 0 ; i -- )
  {
    while ( it < suf_cnt && pref[i] + suf[it] <= cost )
        it ++ ;
    if ( pref[i] + suf[it] > cost )
        answer += suf_cnt - it;
    else
        break;
  };
  return answer;
};

long long g1(long long cost , int pos){
    if ( cost < 0 ) return 0;
    if (pos == L + 1)
    {
      if ( S.find(cost) != S.end() )
            return S[cost];
        else
            return 0;
    };
    long long answer = 0;
    for (int i = 1 ; i <= N ; i ++ )
        answer += g1(cost - Cost[pos][i] , pos + 1);
    return answer;
}

long long g2(long long cost , int pos){
    if ( cost < 0 ) return 0;
    if ( pos == M + 1 )
        return !cost;
    long long answer = 0;
    for (int i = 1 ; i <= N ; i ++ )
        answer += g2(cost - Cost[pos][i] , pos + 1);
    return answer;
}

long long count_equal(long long cost , int length){
    if ( length <= L )
        return g1(cost , length + 1);
    else
        return g2(cost , length + 1);
};

int main()
{
    freopen("aliens.in","r",stdin);
    freopen("aliens.out","w",stdout);
    cin >> N >> M >> K;
    for (int i = 1 ; i <= M ; i ++ )
        for (int j = 1 ; j <= N ; j ++ )
            cin >> Cost[i][j];

    for (int i = 1 ; i <= M ; i ++ )
    {
      min_cost += *min_element(Cost[i] + 1 , Cost[i] + N + 1);
      max_cost += *max_element(Cost[i] + 1 , Cost[i] + N + 1);
    };

    L = M / 2;
    generate_pref(1 , 0);
    generate_suf(L + 1 , 0);
    sort(pref , pref + pref_cnt);
    sort(suf , suf + suf_cnt);

    long long L = min_cost - 1 , R = max_cost + 1 , find_cost = (L + R) / 2;
    for ( ; L < R ; find_cost = (L + R) / 2 )
        if ( count_more(find_cost) >= K )
            L = find_cost + 1;
        else
            R = find_cost;

    find_cost = (L + R) / 2;

    K -= count_more(find_cost);

    for (int i = 1 ; i <= M ; i ++ )
        for (int j = 1 ; j <= N ; j ++ )
        {
            long long get = count_equal(find_cost - Cost[i][j] , i);
            if ( get < K )
                K -= get;
            else
            {
                printf("%c",char('a' + j - 1));
                find_cost -= Cost[i][j];
                break;
            };
        };

    printf("\n");
    return 0;
};
