/* GCC */
#include <iostream>
#include <cstdio>

using namespace std;

const int NMAX = 110000;

int T , N , A[NMAX] , D[NMAX];
unsigned long long Hash[NMAX] , ReverseHash[NMAX] , Mul[NMAX] , Mod = 1000000007 , P = 113;

bool isPalindrom(int L , int R)
{
  if ( L >= R )
    return true;
  return (Hash[R] - Hash[L - 1] * Mul[R - L + 1] % Mod + Mod) % Mod ==
         (ReverseHash[L] - ReverseHash[R + 1] * Mul[R - L + 1] % Mod + Mod) % Mod;
};

int main()
{
    freopen("symmetry.in","r",stdin);
    freopen("symmetry.out","w",stdout);
    scanf("%d",&T);
    for ( ; T -- ; )
    {
      scanf("%d",&N);
      for (int i = 1 ; i <= N ; i ++ )
            scanf("%d",&A[i]);
      for (int i = 2 ; i <= N ; i ++ )
        D[i - 1] = A[i] - A[i - 1];

      Mul[0] = 1;
      for (int i = 1 ; i < N ; i ++ )
      {
        Mul[i] = (Mul[i - 1] * P) % Mod;
        Hash[i] = (Hash[i - 1] * P + D[i]) % Mod;
        ReverseHash[N - i] = (ReverseHash[N - i + 1] * P + D[N - i]) % Mod;
      };


      bool found_answer = false;
      for (int i = 0 ; i < N - 2 ; i ++ )
        if ( isPalindrom(1 , i) && isPalindrom(i + 2 , N - 1) )
        {
          printf("%d\n",i + 1);
          found_answer = true;
          break;
        };
    if ( !found_answer )
        printf("0\n");
    };

    return 0;
};
