/* GCC */
#include <stdio.h>
#include <iostream>
#define name "symmetry"
using namespace std;
const int DEBUG = 0;

int fr[100000], gr[100000];
int fl[100000], gl[100000];
int powA[100000] = {1, };
int field[100000];
int fieldcpy[100000];
const int M = 35521; // Constants generated by flipping a coin for each bit 
const int A = 28764; // Guarenteed to be completly random

void genR(int size){
     fr[1] = gr[1] = 0;
     for(int i = 1; i < size; i++){
       fr[i] = (fr[i-1]+(field[i]-field[i-1])*powA[i-1])%M;
       gr[i] = (field[i]-field[i-1]+gr[i-1]*A)%M;
     }
}

void genL(int size){
     fl[0] = gl[0] = 0;
     for(int i = 1; i < size; i++){
       fl[i] = (fl[i-1]+(fieldcpy[i-1]-fieldcpy[i])*powA[i-1])%M;
       gl[i] = (fieldcpy[i-1]-fieldcpy[i]+gl[i-1]*A)%M;
     }
}

bool actualCheck(int pos, int size){
     for(int i = 1; i < pos; i++)
       if ((field[i] - field[i-1]) != (field[pos-i]-field[pos-i-1])) return false;
     for(int i = pos+1; i < size; i++)
       if ((field[i]-field[i-1]) !=  (field[size+pos-i]-field[size+pos-i-1])) return false;
     return true;
}

int main(){
    if (!DEBUG){
      freopen(name ".in", "r", stdin);
      freopen(name ".out", "w", stdout);
    }
    for(int i = 1; i < 100000; i++) powA[i] = (powA[i-1]*A)%M;
    int tests; scanf("%d", &tests);
    for(int _i = 0; _i < tests; _i++){
        int s; scanf("%d", &s);
        for(int i = 0; i < s; i++){ scanf("%d", &field[i]); fieldcpy[s-1-i] = field[i]; }
        genR(s); genL(s);
        for(int i = 0; i < s-1; i++)
          if (fr[i] == gr[i])
            if (fl[s-i-2] == gl[s-i-2])
              if (actualCheck(i+1, s)){
                printf("%d\n", i+1);
                goto next;
              }
        printf("0\n");
        next:;
    }
    if (DEBUG) system("pause");
}
